package com.syntevo.openapi.smartsvn.gui.menu;

import java.util.*;

/**
 * Allows to get menu actions or menu structures, create menus or remove items.
 */
public interface MenuContainer {

	/**
	 * Returns the number of contained items.
	 */
	int getItemCount();

	/**
	 * Returns the MenuItems (MenuAction or MenuStructure) in their corresponding order.
	 */
	List<? extends MenuItem> getItems();

	/**
	 * Removes the item at the specified index.
	 */
	void removeItem(int index);

	/**
	 * Create a menu resp. sub-menu.
	 *
	 * @param index the index within this container to add the menu at
	 * @param name the name of the sub-menu.
	 */
	MenuStructure createMenu(int index, String name);
}
